//+------------------------------------------------------------------+
//|                                                    cci_ma_ea.mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//---   
input int      StopLoss=30;      // Stop Loss
input int      TakeProfit=50;    // Take Profit
input int      MA_Period=26;     //  Moving Average
input int      CCI_Period1=50;   // CCI  1
input int      CCI_Period2=28;   // CCI  2
input int      EA_Magic=999;     // Magic 
input double   Lot=0.1;          //    
//---  
int maHandle;               //   Moving Average
int cciHandle1,cciHandle2;  //   CCI
double maVal[];             //      Moving Average
double cciVal1[],cciVal2[]; //      CCI
double p1_close,p2_close;   //     2-  
//---    
double cczero = 0.0000;
double ccip = 1.0000;
double ccim = -1.0000;
double ccmaxa = 100.0000;
double ccmaxb = 95.0000;
double ccmina = -100.0000;
double ccminb = -95.0000;
int STP, TKP;              //     Stop Loss  Take Profit
MqlRates mrate[];          //     ,   
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---    Moving Average
   maHandle=iMA(_Symbol,Period(),MA_Period,0,MODE_EMA,PRICE_TYPICAL);
//---    CCI 1
   cciHandle1=iCCI(_Symbol,PERIOD_CURRENT,CCI_Period1,PRICE_TYPICAL);
//---    CCI 2
   cciHandle2=iCCI(_Symbol,PERIOD_CURRENT,CCI_Period2,PRICE_TYPICAL);
//---  ,      Invalid Handle
   if(maHandle<0 || cciHandle1<0 || cciHandle2<0)
     {
      Alert("    -  : ",GetLastError(),"!");
     }

//---    
//---   

//---  
   ArraySetAsSeries(mrate,true);
//---    CCI 1
   ArraySetAsSeries(cciVal1,true);
//---    CCI 2
   ArraySetAsSeries(cciVal2,true);
//---    MA
   ArraySetAsSeries(maVal,true);

//---    3-  5-  , SL  TP   10
   STP = StopLoss;
   TKP = TakeProfit;
   if(_Digits==5 || _Digits==3)
     {
      STP = STP*10;
      TKP = TKP*10;
     }
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---   
   IndicatorRelease(maHandle);
   IndicatorRelease(cciHandle1);
   IndicatorRelease(cciHandle2);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---        
   int Mybars=Bars(_Symbol,_Period);
   if(Mybars<60) //     60
     {
      Alert("   60,    !!");
      return;
     }

//---    MQL5,     
   MqlTick latest_price;      //      
   MqlTradeRequest mrequest;  //      
   MqlTradeResult mresult;    //       

//---     MQL5-  MqlTick
   if(!SymbolInfoTick(_Symbol,latest_price))
     {
      Alert("    - :",GetLastError(),"!!");
      return;
     }

//---      
   if(CopyRates(_Symbol,_Period,0,3,mrate)<0)
     {
      Alert("      - :",GetLastError(),"!!");
      return;
     }

//---           
//---     datetime
   static datetime Prev_time;
//---        (Bar 0)
   datetime Bar_time[1];
//---    
   Bar_time[0]=mrate[0].time;
//---    ,    
   if(Prev_time==Bar_time[0])
     {
      return;
     }
//---   ,       
   Prev_time=Bar_time[0];

//---       ,   
   if(CopyBuffer(maHandle,0,0,5,maVal)<0)
     {
      Alert("    MA - :",GetLastError(),"!");
      return;
     }
   if(CopyBuffer(cciHandle1,0,0,5,cciVal1)<0 || CopyBuffer(cciHandle2,0,0,5,cciVal2)<0)
     {
      Alert("    CCI - :",GetLastError(),"!");
      return;
     }
//---  , 
//---     ,   ( 0)
   p1_close=mrate[1].close;  //     ( 1))
   p2_close=mrate[2].close;  //   ,   ( 2)

//--- ,      ?
   bool Buy_opened=false,Sell_opened=false;
   if(PositionSelect(_Symbol)==true) //       
     {
      if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)
        {
         Buy_opened=true;  //   
         double msl=PositionGetDouble(POSITION_SL);
         double mtp=PositionGetDouble(POSITION_TP);
         if(CheckTrade("BUY")==true)
           {
            Buy_opened=false;
           }
        }
      else if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL)
        {
         Sell_opened=true; //   
         double smsl=PositionGetDouble(POSITION_SL);
         double smtp=PositionGetDouble(POSITION_TP);
         if(CheckTrade("SELL")==true)
           {
            Sell_opened=false;
           }
        }
     }

//---    bool    
   bool Buy_Condition_1=(cciVal1[3]<cczero) && (cciVal1[2]>cczero); // CCI1     
   bool Buy_Condition_2=(p2_close>maVal[2]);                        //    Bar 2  MA
   bool Buy_Condition_3=(p1_close>p2_close);                        //   Bar 1 ,    Bar 2 ()
   bool Buy_Condition_4=(cciVal1[0]>ccip) && (cciVal2[0]>ccip);     //   CCI1>1  CCI2>1

//---    bool    
   bool Sell_Condition_1=(cciVal1[3]>cczero) && (cciVal1[2]<cczero); // CCI1     
   bool Sell_Condition_2=(p2_close < maVal[2]);                      //    Bar 2  MA
   bool Sell_Condition_3=(p1_close<p2_close);                        //   Bar 1 ,    Bar 2 ()
   bool Sell_Condition_4=(cciVal1[0]<ccim) && (cciVal2[0]<ccim);     //   CCI1<-1  CCI2<-1

/*
    1.   
*/
//---   
   if(Buy_Condition_1 && Buy_Condition_2)
     {
      if(Buy_Condition_3 && Buy_Condition_4)
        {
//---    ?
         if(Buy_opened)
           {
            Alert("      !");
            return;    //      
           }
         mrequest.action = TRADE_ACTION_DEAL;                                   //  
         mrequest.price = NormalizeDouble(latest_price.ask,_Digits);            //   ask
         mrequest.sl = NormalizeDouble(latest_price.ask - STP*_Point,_Digits);  // Stop Loss
         mrequest.tp = NormalizeDouble(latest_price.ask + TKP*_Point,_Digits);  // Take Profit
         mrequest.symbol = _Symbol;                                             //  
         mrequest.volume = Lot;                                                 //    
         mrequest.magic = EA_Magic;                                             // Magic 
         mrequest.type = ORDER_TYPE_BUY;                                        //    (Buy)
         mrequest.type_filling = ORDER_FILLING_FOK;                             //   
         mrequest.deviation=100;                                                //     
//---  
         OrderSend(mrequest,mresult);
//---     
         if(mresult.retcode==10009 || mresult.retcode==10008) //     
           {
            Alert("     ,   Ticket#:",mresult.order,"!");
           }
         else
           {
            Alert("        - :",GetLastError());
            return;
           }
        }
     }
/*
    2.   :
*/
//---   
   else if(Sell_Condition_1 && Sell_Condition_2)
     {
      if(Sell_Condition_3 && Sell_Condition_4)
        {
//---    ?
         if(Sell_opened)
           {
            Alert("    !");
            return;    //      
           }
         mrequest.action=TRADE_ACTION_DEAL;                                    //   
         mrequest.price = NormalizeDouble(latest_price.bid,_Digits);           //   Bid
         mrequest.sl = NormalizeDouble(latest_price.bid + STP*_Point,_Digits); // Stop Loss
         mrequest.tp = NormalizeDouble(latest_price.bid - TKP*_Point,_Digits); // Take Profit
         mrequest.symbol = _Symbol;                                            //  
         mrequest.volume = Lot;                                                //    
         mrequest.magic = EA_Magic;                                            // Magic 
         mrequest.type= ORDER_TYPE_SELL;                                       //    (Sell)
         mrequest.type_filling = ORDER_FILLING_FOK;                            //   
         mrequest.deviation=100;                                               //     
//---  
         OrderSend(mrequest,mresult);
//---     
         if(mresult.retcode==10009 || mresult.retcode==10008) //     
           {
            Alert("     ,   Ticket#:",mresult.order,"!");
           }
         else
           {
            Alert("        - :",GetLastError());
            return;
           }
        }
     }
   return;
  }

//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
bool checkClose(string ptype)
  {
   bool mark=false;
   if(ptype=="BUY")
     {
//---     ?
      if(cciVal1[2]>ccmaxa && cciVal1[1]<ccmaxb) // CCI1  +100 
        {
         mark=true;
        }
     }
   if(ptype=="SELL")
     {
//---     ?
      if(cciVal1[2]<ccmina && cciVal1[1]>ccminb)// CCI 1  -100 
        {
         mark=true;
        }
     }
   return(mark);
  }
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
bool CheckTrade(string otyp)
  {
   bool marker=false;
   for(int i=1; i<=PositionsTotal();i++)
     {
      if(PositionSelect(_Symbol)==true)
        {
         if(PositionGetInteger(POSITION_MAGIC)==EA_Magic && PositionGetString(POSITION_SYMBOL)==_Symbol) //  
           {
//--- check if we can close the order
            Alert("checkclose-",otyp," : ",checkClose(otyp));
            if(checkClose(otyp)==true)
              {
               double pvol= PositionGetDouble(POSITION_VOLUME);
               ulong pdev = 100;
               if(CloseTrade(otyp,pvol,pdev)==true)
                 {
                  marker=true;
                 }
              }
           }
        }
     }
   return(marker);
  }
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
bool CloseTrade(string otype,double vol,ulong dev)
  {
   MqlTradeRequest trequest;
   MqlTradeResult tresult;
   ENUM_ORDER_TYPE ptype;
   if(otype=="BUY")
     {
      ptype=ORDER_TYPE_SELL;
      trequest.price=SymbolInfoDouble(_Symbol,SYMBOL_BID);
     }
   else
     {
      ptype=ORDER_TYPE_BUY;
      trequest.price=SymbolInfoDouble(_Symbol,SYMBOL_ASK);
     }
   trequest.action=TRADE_ACTION_DEAL;
   trequest.type=ptype;
   trequest.volume=vol;
   trequest.sl=0;
   trequest.tp=0;
   trequest.deviation=dev;
   trequest.magic=EA_Magic;
   trequest.symbol=_Symbol;
   trequest.type_filling=ORDER_FILLING_FOK;
//---  
   OrderSend(trequest,tresult);
   //---     
   if(tresult.retcode==10009 || tresult.retcode==10008) //     
     {
      Alert("   ,  #:",tresult.order,"!");
      return(true);
     }
   else
     {
      Alert("      - : ",GetLastError());
      return(false);
     }
  }
//+------------------------------------------------------------------+